#!/usr/bin/perl

$LoginNotRequired = 1;
require "event/login.pl";

require "gr/datetime.pl";

if ($c{sid} ne ""){
  %r = &DataGetSessionRec($c{sid});
}

chdir "event";

use event::Tourn;

CgiPrintHeader();

############################
# Set this to the event id; such as 2010wc
############################
#$in{e} = "test6";
$in{e} = "2010wc";

$e = ProcessInputChange($in{e}, 'lower', 'alphaNum');

if ($e eq ''){
  HtmlErrorPage("Need Event", "The event id was not given.");
  exit;
}

if (! Tourn->exists($e)){
  HtmlErrorPage("Need Event", "The event [$e] was not found.");
  exit;
}

$ev = Tourn->load($e);
if (! $ev){
  HtmlErrorPage("Not Read", "Event [$e] could not be read.\n");
  exit;
}

%e = $ev->getEvent();
@games = $ev->getGames();
$round = $ev->getRound();
$status = $ev->getRoundStatus($round);
$eventName = $ev->getEventFullName();

$gmt = "GMT";
if ($r{id} ne ""){ $gmt = "YLT"; }

for($rn=1; $rn<=$round; $rn++){
  $roundName = '';
  $gameRows = "";
  @gameRows = ();
  $clickOnBoard = "";
  $gameTimes = "";
  @p = $ev->getPlayersByRound($rn);
  $pl = '';
  foreach $p (@p){
    $rating{$p->{u}} = $p->{r};
    $orderby = $p->{r};
    if ($p->{orderby} ne ''){
      $orderby = $p->{orderby};
    }
    $pl .= "$p->{u} $orderby<br>\n";
  }
  $format = $ev->getRoundFormat($rn);
  $format = $desc{$format};
  $gl = '';
  $rows = '';
  @g = $ev->getGamesByRound($rn);
  foreach $g (@g){
    ($w, $b, $ts, $tc, $why, $ply, $gid) = ($g->{1}, $g->{2}, $g->{schts}, $g->{timecontrol}, $g->{why}, $g->{move}, $g->{gid});
    ($wr, $br) = ($rating{$w}, $rating{$b});
    $wwin = ''; $bwin = '';
    if ($g->{won} eq '1'){ $wwin = '*'; }
    if ($g->{won} eq '2'){ $bwin = '*'; }
    if ($g->{won} eq 'd'){ $wwin = '='; $bwin = '='; }

    if ($tc eq ''){
      $tc = $ev->getRoundTimecontrol($rn);
    }
    $tc = qq(<a href="/arimaa/gameroom/timecontrol.cgi?tc=$tc" target=_blank>$tc</a>);

    $scheduled = ($ts>0) ? &getDayHrMin($ts - $r{timezone}) : '';
    $scheduled = ($ply ne "") ? "<a href='javascript:reasonCodes()'>$why</a> $ply" : $scheduled;

    if ($g->{won} ne ''){ $clickOnBoard = 1; }
    else{
      if ($ts>0){ $gameTimes = 1; }
    }

    $board = <<EOM;
<table background="/arimaa/graphics/BoardWithPiecesIcon.jpg" width=50 height=50 border=0 cellspacing=0 cellpadding=0>
  <tr>
    <td >
<a href="javascript:openGame('$gid','v','w');" >
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
    <td >
<a href="javascript:openGame('$gid','v','b');" >
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
  </tr>
</table>
EOM

    if ($w eq $b){
      $gameRow = <<EOM;
<tr>
  <td align=right>
    <a href="javascript:playerPage('$w')">$w</a><br><font size=-1>$wr</font>
  </td>
  <td align=center>
    <font size=1>$scheduled</font>$board
  </td>
  <td align=left>bye
  </td>
</tr>
EOM
      $gameRows .= $gameRow;
      push(@gameRows, "$ts $gameRow");
      next;
    }
    $gameRow = <<EOM;
<tr>
  <td align=right>
    <nobr>$wwin <a href="javascript:playerPage('$w')">$w</a><br><font size=-1>$wr</font></nobr>
  </td>
  <td align=center>
    <font size=1>$scheduled</font>$board
  </td>
  <td align=left>
    <nobr><a href="javascript:playerPage('$b')">$b</a> $bwin<br><font size=-1>$br</font></nobr>
  </td>
</tr>
EOM
    $gameRows .= $gameRow;
    push(@gameRows, "$ts $gameRow");
  }

  @gameRows = sort(@gameRows);
  foreach (@gameRows){
    $_ =~ s/^\d+ //;
  }
  $gameRows = join("\n", @gameRows);

  if ($clickOnBoard){
    $clickOnBoard = <<EOM;
  <tr>
    <td></td>
    <td colspan=2 align=left>
<font size=-2>
Click board to view game
</font>
    </td>
  </tr>
EOM
  }

  if ($roundName eq ""){
    $roundName = "Round $rn";
  }

  if ($gameTimes){
    $gameTimes = <<EOM;
  <tr>
    <td></td>
    <td colspan=2 align=left>
<font size=-2>
Times are in $gmt
</font>
    </td>
  </tr>
EOM
  }

  $watchGames .= <<EOM;
<td valign=top>
<table border=0>
  <tr><td></td>
    <td colspan=2 align=left>
<b>
$roundName
</b>
    </td>
  </tr>
  <tr>
    <td align=right>
      Gold
    </td>
    <td align=center>
      &nbsp;
    </td>
    <td align=left>
      Silver
    </td>
  </tr>
  $gameTimes
  $clickOnBoard
  $gameRows
</table>
<td>
EOM

  $func = <<EOM;
    <script language="JavaScript1.2">
<!--
function playerPage(u){
    open('/arimaa/gameroom/playerpage.cgi?u='+u,'','toolbar=no,width=650,height=450,scrollbars=yes,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
    void('');
}

function comPage(g){
    open('/arimaa/gameroom/comments.cgi?gid='+g,'','');
    void('');
}

function reasonCodes(){
  open('/arimaa/gameroom/reasonCodes.html','','toolbar=no,width=650,height=450,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
}

function openGame(id, role, side){
  if (parseInt(id) > 0){
//    open('/arimaa/games/showGame.cgi?gid='+id+'&s='+side,'','toolbar=no,width=350,height=250,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
    open('/arimaa/gameroom/comments.cgi?gid='+id,'','');
  }
  else{
    if (parseInt(id) == 0){
      alert("Game was won by forfeit");
    }
    else{
      alert("To watch the game login to the Arimaa gameroom and use 'Current Games'");
    }
  }
  void('');
}

// -->
    </script>
EOM

}

print <<EOM;
<html>
  <head><title>$eventName</title>
  </head>
  <body bgcolor=#d8d8f8>
$func
    <center>
<p><font size=+2><b>$eventName</b></font>
<p>
    <table>
      <tr>
$watchGames
      </tr>
    <table>
    </center>
  </body>
</html>

EOM

exit;


